<?php
// Require functions page.
require_once("../includes/functions.php");

$page_area = "Update";
$page_header = "Update This Software: <b>" .$cms['version_full']. "</b>";
require("includes/header.php");

// Get update file for latest version
// The following is the old method. Technically not allowed, so some servers have issues with it.
//require("http://www.quate.net/labs/chris/updates.txt");

// This setting may or may not allow some restricted servers to access files outside of its network.
//ini_set('allow_url_fopen', 1);

// Current (Alternative Method) to check for latest version
/*
$remotedata = file_get_contents($cms['update_url']);

// Function to fetch php variable values from remote text file.
function fetchvalue($getvalue, $data) {
 $data = preg_replace("/" .$term. "\ \=\ \"(.*?)\"\;/", "\\1", $data);
 $part1 = explode($getvalue. "", $data);
 $part2 = explode("
", $part1['1']);
 return $part2['0'];
}

$update_cms['version'] = fetchvalue("update_cms['version']", $remotedata);
$update_cms['notes'] = fetchvalue("update_cms['notes']", $remotedata);
$update_cms['download'] = fetchvalue("update_cms['download']", $remotedata);

// Determine if the CMS is the latest.

if ($update_cms['version'] > $cms['version']) {
 $update_text = "An new version (" .$update_cms['version']. ") is available.";
 if ($update_cms['notes'] != "") {
  $update_text .= " " .$update_cms['notes'];
 }
 $update_text .= " Download it <a href=\"" .$update_cms['download']. "\">here</a>.<br>Note: Before upgrading, please read the upgrade manual provided in this download.";
} else {
 $update_text = "You have the latest version.";
}
*/

	$content = fetch_remote_file($cms['update_url']);
	// see: http://www.ibm.com/developerworks/library/x-xmlphp1.html
	$dom = new domDocument;
	$dom->loadXML($content);
	if (!$dom) {
		report_error("E_MSG", "Error parsing the xml update document.", __FILE__, __LINE__);
		exit;
	}

	$update_cms['version'] = "";
	
	$xml = simplexml_import_dom($dom);
	// Run through xml until an entry for this software is found.
	$found = 0;
	foreach ($xml as $software) {
		if ($software->name == $cms['version_full']) {
			$found = 1;
			$update_cms['version'] = $software->version;
			if ($software->version > $cms['version_number']) {
				$pg['content'] .= "<p>A new " .$cms['name']. " release, version  " .$software->versionFull. ", is available.</p>";
				if ($software->releaseNotes != "") {
					$pg['content'] .= "<p>" .$software->releaseNotes. "</p>";
				}
$pg['content'] .= "<input type=\"button\" value=\"View Website\" onclick=\"document.location.href = '" .$software->websiteUrl. "';\" />
<input type=\"button\" value=\"Direct Download\" onclick=\"document.location.href = '" .$software->downloadUrl. "';\" />
<input type=\"button\" value=\"Cancel\" onclick=\"document.location.href = './';\" />";
			} else {
				$pg['content'] .= "<p>No new update was found. You are using the latest version.</p>
<input type=\"button\" value=\"Okay\" onclick=\"document.location.href = './';\" />";
			}
		}
		//echo $software->name. ' version ' .$software->version. '<br />';
	}
	//http://www.openjs.com/scripts/jx/
	if ($found == 0) {
		$pg['content'] .= "<p>No update information was found.
You should manually check for updates at our <a href=\"http://www.quate.net/quatecms\" target=\"_blank\">website</a>.</p>
<input type=\"button\" value=\"Okay\" onclick=\"document.location.href = './';\" />";
	}

//
// Update Nofitier
// Update update notifier file with current date.
require_once("../includes/config.php");
if ($adv_settings['use_update_notifier'] == "1") {
 $file = "logs/update_check";
 if ($file_open = fopen($file, "r")) {
  // Write date.
  $file_open = fopen($file, "w");
  $new_content = date("z|y");
  if (!fwrite($file_open, $new_content)) {
   // Count not write to log file.
  }
  fclose($file_open); // Close file.
 }
 //
 // Save Latest Version
 $file = "logs/latest_version";
 if ($file_open = fopen($file, "r")) {
  // Write date.
  $file_open = fopen($file, "w");
  $new_content = $update_cms['version'];
  if (!fwrite($file_open, $new_content)) {
   // Count not write to log file.
  }
  fclose($file_open); // Close file.
 }
}
?>
<table cellspacing="0" cellpadding="0">
<tr>
       <td><img src="images/system-software-update_large.png" width="48" height="48" alt="" border="0" hspace="5"></td>
       <td width="500"><?php echo $pg['content']; ?></td>
</tr>
</table>
<?php
require("includes/footer.php");
?>