<?php
// Require functions page.
require_once("includes/functions.php");

// Connect to the database!
// (Config file was included in this connect file.  No need to include it again.)
require_once("includes/connect.php");

// If locked.
if (is_file("includes/lock")) {
 // Use normal layout or simple_gui layout?
 if ($lock['enable_layout'] == 1) {
  $page_title = $lock['title'];
  require_once("includes/header.php"); // Show header
  echo $lock['msg'];
  require_once("includes/footer.php"); // Show footer
 } else {
  $simple_gui['title'] = $lock['title'];
  $simple_gui['mode'] = "header";
  require("includes/simple_gui.php");
  echo $lock['msg'];
  $simple_gui['mode'] = "footer";
  require("includes/simple_gui.php");
 }
 exit(); // Exit script.
}

$short_url = get_short_url('0');
if ($short_url == "") {
 if ($_GET['link']) {
  $page = $_GET['link'];
 } else if ($_GET['link']) {
  $link = $_GET['link'];
 }
} else {
 $link = $short_url;
}

// If $link is empty
if ($link == "") {
 header("status: 404");
 header("HTTP/1.0 404 Not Found");
 // exit script.
 exit();
}

function error_msg($e_layout, $e_msg) {
// Sometimes this function won't be able to grab the config variables because it is part of a die() function, so variables that it used must be declared for the function.
 // Use normal layout or simple_gui layout?
 if ($e_layout == 1) {
  $page_title = "Error";
  require_once("includes/header.php"); // Show header
  echo $e_msg;
  $simple_gui['mode'] = "footer";
  require_once("includes/footer.php"); // Show footer
 } else {
  $simple_gui['title'] = "Error";
  $simple_gui['mode'] = "header";
  require("includes/simple_gui.php");
  echo $e_msg;
  $simple_gui['mode'] = "footer";
  require("includes/simple_gui.php");
 }
}

function link_error() {
 header("status: 404");
 header("HTTP/1.0 404 Not Found");
 exit();
}

// Query database (and check if $page is a number or something else).
if (is_numeric($link)) {
 // Is a number
 
 $query = "SELECT * FROM " .SQL_PREFIX. "linkcount WHERE linkcount_id = '" .sql_protect($link). "'";
 $result = mysql_query($query) or die(report_error("E_DB", link_error(), __LINE__, __FILE__));
 $row = mysql_fetch_array($result) or die(mysql_error());
 
} else {
 // Is a string (text)
 
 $link = str_replace("%26", "&amp;", $link);
 $link = str_replace("'", "&#39;", $link);
 $link = str_replace("%20", " ", $link);
 
 $query = "SELECT * FROM " .SQL_PREFIX. "linkcount WHERE linkcount_name = '" .sql_protect($link). "'";
 $result = mysql_query($query) or die(report_error("E_DB", link_error(), __LINE__, __FILE__));
 $row = mysql_fetch_array($result) or die(mysql_error());
 
}
extract($row);

require_once("includes/extensions/Linkcount/checkbot.php");

// Only work if user is not a bot.
if (checkbot() == "nobot") {
 // Update # of views.
 $total_views = $linkcount_count + 1;
 $query = "UPDATE " .SQL_PREFIX. "linkcount SET linkcount_count = '" .$total_views. "' WHERE linkcount_id = '" .$linkcount_id. "'";
 $result = mysql_query($query) or die(report_error("E_DB", mysql_error(), __LINE__, __FILE__));

 session_start();

 // If unique views has already been updated.
 if (isset($_COOKIE["linkcount-" .$linkcount_id. ""]) | isset($_SESSION["linkcount-" .$linkcount_id. ""])) {
  // Don't update. Already updated.
 } else {
  // Update # of unique.
  $total_views_unique = $linkcount_count_unique + 1;
  $query = "UPDATE " .SQL_PREFIX. "linkcount SET linkcount_count_unique = '" .$total_views_unique. "' WHERE linkcount_id = '" .$linkcount_id. "'";
  $result = mysql_query($query) or die(report_error("E_DB", mysql_error(), __LINE__, __FILE__));

  // Set cookies and sessions.
  setcookie("linkcount-" .$linkcount_id. "", '1', time()+86400);
  $_SESSION["linkcount-" .$linkcount_id. ""] = 1;
 }

 // Redirect.
 $file = $linkcount_url;
 $filename = basename($file);
 
 header ("Cache-Control: must-revalidate, post-check=0, pre-check=0");
 header ("Content-Type: application/octet-stream");
 //header ("Content-Length: " . filesize($file));
 header ("Content-Disposition: attachment; filename=" .$filename);
 echo readfile($file);
} else {
 // If user is a bot, give error page. Bot shouldn't be here.
 header("status: 403");
 header("HTTP/1.0 403 Forbidden");
}
?>