<?php
// Require functions page.
require_once("includes/functions.php");

// Make sure database setup has been run
if (!is_file("includes/installed")) {
	$simple_gui['title'] = "CMS Not Installed";
	$simple_gui['head'] .= "";
	$simple_gui['body'] .= "";
	$simple_gui['content'] .= "The installer needs to be run before the CMS can work properly.";
	$level = "";
	require("includes/simple_gui.php");
	exit();
}

// Connect to the database!
// (Config file was included in this connect file.  No need to include it again.)
require_once("includes/connect.php");

// If locked.
if (is_file("includes/lock")) {
	// Use normal layout or simple_gui layout?
	if ($lock['enable_layout'] == 1) {
		$page_title = $lock['title'];
		require_once("includes/header.php"); // Show header
		echo $lock['msg'];
		require_once("includes/footer.php"); // Show footer
	} else {
		$pg['title'] .= $lock['title'];
		$pg['head'] .= "";
		$pg['body'] .= "";
		$pg['content'] .= $lock['msg'];
		$level = "";
		require("includes/simple_gui.php");
	}
	exit(); // Exit script.
}

$short_url = get_short_url('0');
if ($short_url == "") {
 if ($_GET['p']) {
  $page = $_GET['p'];
 } else if ($_GET['page']) {
  $page = $_GET['page'];
 }
} else {
 $page = $short_url;
}

// If $page is empty
if ($page == "") {
 // Default page id, since none was defined.
 $page = $pg_default['start'];
}

function error_msg($e_layout, $e_msg) {
// Sometimes this function won't be able to grab the config variables because it is part of a die() function, so variables that it used must be declared for the function.
	// Use normal layout or simple_gui layout?
	if ($e_layout == 1) {
		$page_title = "Error";
		require_once("includes/header.php"); // Show header
		echo $e_msg;
		$simple_gui['mode'] = "footer";
		require_once("includes/footer.php"); // Show footer
	} else {
		$pg['title'] .= "Error";
		$pg['head'] .= "";
		$pg['body'] .= "";
		$pg['content'] .= $e_msg;
		$level = "";
		require("includes/simple_gui.php");
	}
}

// Set include error message.
$include_msg = $pg_default['include_error'];

// Query database (and check if $page is a number or something else).
if (is_numeric($page)) {
 // Is a number
 
 // Uses sql_protect because $page comes from a $_GET variable.
 if (isset($_COOKIE['quatecms_lang'])) {
	$query = "SELECT * FROM " .SQL_PREFIX. "page WHERE page_lang = '" .sql_protect($_COOKIE['quatecms_lang']). "' AND page_lang_parent = '" .sql_protect($page). "'";
 } else {
	$query = "SELECT * FROM " .SQL_PREFIX. "page WHERE page_id = '" .sql_protect($page). "'";
 }
 
} else {
 // Is a string (text)
 
 $page = str_replace("%26", "&amp;", $page);
 $page = str_replace("'", "&#39;", $page);
 $page = str_replace("%20", " ", $page);
 
 // Uses sql_protect because $page comes from a $_GET variable.
 if (isset($_COOKIE['quatecms_lang'])) {
	// Get page id from page_name query.
	$query_tmp = "SELECT * FROM " .SQL_PREFIX. "page WHERE page_name = '" .sql_protect($page). "'";
	$result_tmp = mysql_query($query_tmp) or die(report_error("E_DB", mysql_error(), __LINE__, __FILE__));
	$row_tmp = mysql_fetch_array($result_tmp) or die(error_msg($pg_default['error_enable_layout'], $pg_default['error']));
 
	$query = "SELECT * FROM " .SQL_PREFIX. "page WHERE page_lang = '" .sql_protect($_COOKIE['quatecms_lang']). "' AND page_lang_parent = '" .$row_tmp['page_id']. "'";
 } else {
	$query = "SELECT * FROM " .SQL_PREFIX. "page WHERE page_name = '" .sql_protect($page). "'";
 }
}

$result = mysql_query($query) or die(report_error("E_DB", mysql_error(), __LINE__, __FILE__));
$row = mysql_fetch_array($result) or die(error_msg($pg_default['error_enable_layout'], $pg_default['error']));
extract($row);

// If page is hidden from view.
if ($page_visible == 0) {
 echo error_msg($pg_default['error_enable_layout'], $pg_default['error']);
 exit();
}
if ($page_trash != 0) {
 echo error_msg($pg_default['error_enable_layout'], $pg_default['error']);
 exit();
}

// Update # of views
$total_views = $page_views + 1;
$query = "UPDATE " .SQL_PREFIX. "page SET page_views = '" .$total_views. "' WHERE page_id = '" .$page_id. "'";
$result = mysql_query($query) or die(report_error("E_DB", mysql_error(), __LINE__, __FILE__));

// If redirect (check if page should be included, then check if it needs to be redirected instead.)
if (!$page_include == "") {
 if ($page_redirect == 1) {
  header("Location: " .$page_include. "");
 } else {
  // This will be dealt with a little later in the script.
 }
}

// Show header
require_once("includes/header.php");

// Deal with text format:
// If text format is set to "Normal Text."
if ($page_format == 0) {
 $page_text = str_replace("
", "<br>", $page_text); // <
}

// Issue fix with & sign and html special chars...
$page_text = str_replace("&amp;", "&", $page_text);
$page_text = str_replace("& ", "&amp; ", $page_text);

// Check to see if the page should be included, and display
if (!$page_include == "")
{
 if (!include($page_include))
 {
  // If the page wasn't included.
  echo $include_msg;
 }
} else {
 // Show content
 echo $page_text;
}

//
// Show footer
require_once("includes/footer.php");

if ($adv_debug['mode'] == "1") {
 // Include debug mode page.
 require_once("includes/debug.php");
}
?>