<?php
// Require functions page.
require_once("includes/functions.php");

// Make sure database setup has been run
if (!is_file("includes/installed")) {
 $simple_gui['title'] = "CMS Not Installed";
 $simple_gui['mode'] = "header";
 require("includes/simple_gui.php");
 echo "The installer needs to be run before the CMS can work properly.";
 $simple_gui['mode'] = "footer";
 require("includes/simple_gui.php");
 exit();
}

// Connect to the database!
// (Config file was included in this connect file.  No need to include it again.)
require_once("includes/connect.php");

if ($rss_default['enabled'] == 1) {

 // Determine RSS type.
 if ($_GET['type'] == "") {
  $rss_type = $rss_default['rss_type'];
 } else {
  $rss_type = $_GET['type'];
 }

 // Determine item limit to display
 if ($_GET['limit'] == "") {
  if ($rss_default['limit'] == "") {
   $rss_limit = 15; // Default limit.
  } else {
   $rss_limit = $rss_default['limit']; // User defined dafult limit.
  }
 } else {
  $rss_limit = $_GET['limit']; // User defined limit.
 }
 
 // Determine when to cut the description (# of characters).
 if ($rss_default['description_cut'] == "") {
  $rss_description_cut = 300;
 } else {
  $rss_description_cut = $rss_default['description_cut'];
 }
 
 // Strip HTML to get raw text.
 function raw_text($text) {
  // Strip CSS within stylesheets.
  $text = preg_replace("/\<style[^>]*\>[^>]*\<\/style\>/iU", "", $text);
  // Strip HTML comments. (This must go before the javascript code strip, because otherwise javascript code that's commented out will not be stripped.)
  $text = preg_replace("/\<\!\-\-[^>]*\\-\-\>/iU", "", $text);
  // Strip code within javascript.
  $text = preg_replace("/\<script[^>]*\>[^>]*\<\/script\>/iU", "", $text);
  // Strip HTML tags.
  $text = strip_tags($text);
  return $text;
 }
 
 // Figure out location of this directory on server
 function backlocation($back, $url) {
  $self = $url;
  $self = str_replace("\\", "/", $self);
  $self_pieces = explode("/", $self);
  $self_count = count($self_pieces);
  foreach ($self_pieces as $name) {
   if ($for_count < ($self_count - $back)) {
    $http_path .=  $self_pieces[$for_count]. "/";
    $for_count++;
   }
  }
  return $http_path;
 }
 $location = backlocation(1, $_SERVER['PHP_SELF']);
 if ($location == "") {
  $location = "/";
 }
 $location = "http://" .$_SERVER['HTTP_HOST']. "" .$location;
 
 // If rss settings are empty:
 if (!$rss_default['name']) {
  $rss_default['name'] = $_SERVER['HTTP_HOST']. " RSS Feed";
 }
 if (!$rss_default['link']) {
  $rss_default['link'] = "http://" .$_SERVER['HTTP_HOST'];
 }
 if (!$rss_default['description']) {
  $rss_default['description'] = "RSS Feed for " .$_SERVER['HTTP_HOST']. ".";
 }

 // Look for a favicon as the feed image if one is not specifed.
 if ($rss_default['image'] == "") {
  if (file_exists("favicon.png")) {
   $rss_default['image'] = $location. "favicon.png";
  }
  if (file_exists("favicon.ico")) {
   $rss_default['image'] = $location. "favicon.ico";
  }
 }

 // Figure out rss version and display RSS.
 if ($rss_type == "2.0") {
  // RSS 2.0
  echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<rss version=\"2.0\" xmlns:dc=\"http://purl.org/dc/elements/1.1/\">
<channel>
    <title>" .$rss_default['name']. "</title>
    <link>" .$rss_default['link']. "</link>
    <description>" .$rss_default['description']. "</description>
    <language>" .$rss_default['language']. "</language>
    <image>
        <title>" .$_SERVER['HTTP_HOST']. "</title>
        <link>" .$rss_default['link']. "</link>
        <url>" .$rss_default['image']. "</url>
    </image>";
  $query = "SELECT page_id, page_title, page_text, page_visible, page_format, page_include FROM " .SQL_PREFIX. "page WHERE page_visible = '1' AND page_include = '' AND page_trash = '' ORDER BY page_id DESC";
  $results = mysql_query($query) or die(); // Display nothing if fails. This IS an rss feed.
  while ($row = mysql_fetch_array($results)) {
   extract($row);
   echo "\n    <item>
      <title>" .$page_title. "</title>
      <link>" .$location. "index.php?" .$page_id. "</link>
      <description>" .textcut(raw_text($page_text), $rss_description_cut). "</description>
    </item>";
  }
  echo "\n</channel>
</rss>";
 } else if ($rss_type == "0.91") {
  // RSS 1.0
  echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<rss version=\"0.91\">
<channel>
    <title>" .$rss_default['name']. "</title>
    <link>" .$rss_default['link']. "</link>
    <description>" .$rss_default['description']. "</description>
    <language>" .$rss_default['language']. "</language>";
  $query = "SELECT page_id, page_title, page_text, page_visible, page_format, page_include FROM " .SQL_PREFIX. "page WHERE page_visible = '1' AND page_include = '' AND page_trash = ''";
  $results = mysql_query($query) or die(); // Display nothing if fails. This IS an rss feed.
  while ($row = mysql_fetch_array($results)) {
   extract($row);
   echo "\n    <item>
      <title>" .$page_title. "</title>
      <link>" .$location. "index.php?" .$page_id. "</link>
      <description>" .textcut(raw_text($page_text), $rss_description_cut). "</description>
    </item>";
  }
  echo "\n</channel>
</rss>";
 }
} else {
 // RSS disabled. Give 403 forbidden error.
 header("status: 403");
 header("HTTP/1.0 403 Forbidden");
}
?>