<?php
require("../includes/config.php");
require("../includes/functions.php");

$page_area = "Upgrade";
$page_header = "Upgrade the QuateCMS";
// Bypass restricted area
$bypass_restrict = "1";
$bypass_installed = "1";
$secure_page_path = "../" .$admin['dir']. "/";
require("header.php");

// Run checks/processes before allowing an upgrade.

// Create 'lock' file for includes directory to lock cms.
if (!is_file("../includes/lock")) {
 $file_open = fopen("../includes/lock", "a");
 fclose($file_open); // Close file.
}
// Check to see if the lock on the upgrader is still in place.
if (is_file("lock")) {
 echo "<img src=\"../" .$admin['dir']. "/images/no.png\"> The upgrader can not run if the upgrade script is locked. Delete the 'lock' file in the 'upgrade' directory.";
 require("footer.php");
 exit();
}

if ($_GET['cfm'] == "1") {
 $page_area = "Upgrading";
 $page_header = "Upgrading the QuateCMS";
 // Bypass restricted area
 $bypass_restrict = "1";
 $bypass_installed = "1";

?><img src="../<?php echo $admin['dir']; ?>/images/cmslogo.png" style="margin: 7px;"><br><?php

 // Starting to install the QuateCMS.
 echo "<b>QuateCMS Upgrader</b> for version " .$cms['version']. ".<br>";
 echo "The upgrader will tell you step by step what has been done to upgrade the QuateCMS.<br><br>";

 // Connect to the database.
 require_once("../includes/connect.php");
 
 if ($_GET['old_version'] == "0.3.3" || $_GET['old_version'] == "0.3.2" || $_GET['old_version'] == "0.3.1" || $_GET['old_version'] == "0.3" || $_GET['old_version'] == "0.2.9" || $_GET['old_version'] == "0.2.9.1") {
  echo "Updating tables (for 0.3):<br>";
  // Database upgrader from 0.3 RC1 or 0.3 RC2 to 0.3
  // (Running this if 0.3 was installed won't add the table field again.)
  // NOTE: Adding "or die()" to mysql_query will stop the server if the alter table element already exists. We don't want this, because we don't know if these elements are already in the MySQL tables. No error catch is better in this case.  
  $query = "ALTER TABLE " .SQL_PREFIX. "groups ADD groups_privs_filemanager int(11) NOT NULL default '0'";
  $result = mysql_query($query);
  echo "<img src=\"images/yes.png\"> Table " .SQL_PREFIX. "groups updated (1).<br>";

  $query = "ALTER TABLE " .SQL_PREFIX. "groups ADD groups_privs_categories int(11) NOT NULL default '0'";
  $result = mysql_query($query);
  echo "<img src=\"images/yes.png\"> Table " .SQL_PREFIX. "groups updated (2).<br>";
  
  echo "Updating tables (for 0.3.1):<br>";
  $query = "ALTER TABLE " .SQL_PREFIX. "page ADD page_category int(11) NOT NULL default '1'";
  $result = mysql_query($query);
  echo "<img src=\"images/yes.png\"> Table " .SQL_PREFIX. "page updated (1).<br>";
  
  $query = "ALTER TABLE " .SQL_PREFIX. "account ADD account_theme text NOT NULL default ''";
  $result = mysql_query($query);
  echo "<img src=\"images/yes.png\"> Table " .SQL_PREFIX. "account updated (1).<br>";
  
  // Database upgrader from 0.3 to 0.3.1.
  $category = "CREATE TABLE IF NOT EXISTS " .SQL_PREFIX. "category (
  category_id int(11) NOT NULL auto_increment,
  category_name text NOT NULL,
  category_description text NOT NULL,
  category_subcategory int(11) NOT NULL,
  category_subcategory_level int(11) NOT NULL,
  PRIMARY KEY (category_id)
)";
  $result = mysql_query($category) or die ("<b>MySQL Error</b>: " .mysql_error());
  echo "<img src=\"images/yes.png\"> Created table " .SQL_PREFIX. "category (if didn't already exist).<br>";
  
  $query = "SELECT * FROM " .SQL_PREFIX. "category";
  $result = mysql_query($query);
  $num_rows = mysql_num_rows($result);
  // If no categories already exist (from upgrade when settings were kept).
  if ($num_rows == 0) {
	$default_category = "Main";
	$default_category_description = "This is the main category.";

	// Add 'Main' category.
	$query = "INSERT INTO " .SQL_PREFIX. "category(category_name, category_description, category_subcategory, category_subcategory_level)
VALUES('" .$default_category. "', '" .$default_category_description. "', 0, 1)";
	$result = mysql_query($query);
	 echo "<img src=\"images/yes.png\"> Created the default category '" .$default_category. "'.<br>";
}
  
  echo "Updating tables (for 0.3.4):<br>";
  // New to upgrade to 0.3.4:
  $query = "ALTER TABLE " .SQL_PREFIX. "page CHANGE `page_creator` `page_modified` INT(11) NOT NULL DEFAULT '0'";
  $result = mysql_query($query);
  echo "<img src=\"images/yes.png\"> Table " .SQL_PREFIX. "pages updated (2).<br>";
  $query = "ALTER TABLE " .SQL_PREFIX. "page ADD page_modified_last text NOT NULL default '0'";
  $result = mysql_query($query);
  echo "<img src=\"images/yes.png\"> Table " .SQL_PREFIX. "pages updated (3).<br>";
  $query = "ALTER TABLE " .SQL_PREFIX. "page ADD page_lang text NOT NULL default ''";
  $result = mysql_query($query);
  echo "<img src=\"images/yes.png\"> Table " .SQL_PREFIX. "pages updated (4).<br>";
  $query = "ALTER TABLE " .SQL_PREFIX. "page ADD page_lang_parent int(11) NOT NULL default '0'";
  $result = mysql_query($query);
  echo "<img src=\"images/yes.png\"> Table " .SQL_PREFIX. "pages updated (5).<br>";
  $query = "ALTER TABLE " .SQL_PREFIX. "groups CHANGE `groups_privs_modify_others` `groups_privs_pages` INT(11) NOT NULL DEFAULT '0'";
  $result = mysql_query($query);
  echo "<img src=\"images/yes.png\"> Table " .SQL_PREFIX. "groups updated (3).<br>";
  
 //
 // Transfer old config settings to new config settings.
 // Should work for 0.3rc1, 0.3rc2 and 0.3, 0.3.1, 0.3.2, and 0.3.3
 
 // New config file replaces old config file. A backup of the old file is kept for data transfering.
 if (!file_exists("../includes/config.php")) {
	echo "<img src=\"images/no.png\"> It apears that the CMS has never been installed. This is an upgrade script, only for if you already have the QuateCMS installed and you wish to upgrade to a later version.";
	require("footer.php");
	exit();
 } else {
	if (is_file("../includes/config.php") && is_writeable("../includes/config.php")) {
		if (is_file("../includes/config_old.php") && is_writeable("../includes/config_old.php")) {
			unlink("../includes/config_old.php");
		}
		rename("../includes/config.php", "../includes/config_old.php");
		copy("../includes/config_.php", "../includes/config.php");
	} else {
		echo "<img src=\"images/no.png\"> There seem to be no write permissions for 'includes/config.php' which means that configuration settings cannot be transfered over.
You will have to manually edit your config file:<br>
1. Rename your current config file (<i>includes/config.php</i>) to something like <i>includes/config_old.php</i>.<br>\n
2. Rename <i>includes/config_.php</i> to <i>includes/config.php</i>.<br>\n
3. Edit <i>includes/config.php</i> to match all the values in the double quotations from the <i>includes/config_old.php</i> backup file you made.
4. Create an empty file called <i>lock</i> (no extension) and add it to the <i>/upgrade/</i> folder.
Alternatively you may delete the <i>/upgrade/</i> folder entirely.
Either technique will help prevent exploits involving.<br>\n
5. Login to the admin panel and see if the upgrade worked.
Refer to the <a href=\"../manual/\">manual</a> if you are having any trouble with the CMS.";
		require("footer.php");
		exit();
	}
 }
 
 // General.
 // If new settings values were added, then they would equal NULL. So we should assign default values to them.
 if ($pg_lang['use'] == "") {
  $pg_lang['use'] = "1";
 }
 writeconfig("pg_lang['use']", $pg_lang['use'], "../includes/");
 writeconfig("pg_title['prefix']", $pg_title['prefix'], "../includes/");
 writeconfig("pg_default['start']", $pg_default['start'], "../includes/");
 writeconfig("pg_default['error']", $pg_default['error'], "../includes/");
 writeconfig("pg_default['error_enable_layout']", $pg_default['error_enable_layout'], "../includes/");
 writeconfig("pg_default['include_error']", $pg_default['include_error'], "../includes/");
 writeconfig("lock['msg']", $lock['msg'], "../includes/");
 writeconfig("lock['title']", $lock['title'], "../includes/");
 writeconfig("lock['enable_layout']", $lock['enable_layout'], "../includes/");
 
 // Database.
 writeconfig("db_connect['host']", $db_connect['host'], "../includes/");
 writeconfig("db_connect['name']", $db_connect['name'], "../includes/");
 writeconfig("db_connect['prefix']", $db_connect['prefix'], "../includes/");
 writeconfig("db_connect['user']", $db_connect['user'], "../includes/");
 writeconfig("db_connect['pass']", $db_connect['pass'], "../includes/");
 
 // RSS.
 writeconfig("rss_default['enabled']", $rss_default['enabled'], "../includes/");
 writeconfig("rss_default['rss_type']", $rss_default['rss_type'], "../includes/");
 writeconfig("rss_default['name']", $rss_default['name'], "../includes/");
 writeconfig("rss_default['link']", $rss_default['link'], "../includes/");
 writeconfig("rss_default['description']", $rss_default['description'], "../includes/");
 writeconfig("rss_default['language']", $rss_default['language'], "../includes/");
 writeconfig("rss_default['image']", $rss_default['image'], "../includes/");
 writeconfig("rss_default['limit']", $rss_default['limit'], "../includes/");
 writeconfig("rss_default['description_cut']", $rss_default['description_cut'], "../includes/");

 // Admin.
 writeconfig("admin['timeout']", $admin['timeout'], "../includes/");
 writeconfig("admin['dir']", $admin['dir'], "../includes/");
 writeconfig("admin_page['trash_logout']", $admin_page['trash_logout'], "../includes/");
 writeconfig("admin_clean_urls['enable']", $admin_clean_urls['enable'], "../includes/");
 
 // Advanced.
 // If new settings values were added, then they would equal NULL. So we should assign default values to them.
 if ($adv_settings['use_update_notifier'] == "") {
  $adv_settings['use_update_notifier'] = "1";
 }
 if ($adv_settings['update_notifier_frequency'] == "") {
  $adv_settings['update_notifier_frequency'] = "14";
 }
 if ($adv_settings['update_notifier_frequency'] == "") {
  $adv_settings['update_notifier_frequency'] = "0";
 }
 writeconfig("adv_settings['encoding']", $adv_settings['encoding'], "../includes/");
 writeconfig("adv_settings['use_update_notifier']", $adv_settings['use_update_notifier'], "../includes/");
 writeconfig("adv_settings['update_notifier_frequency']", $adv_settings['update_notifier_frequency'], "../includes/");
 writeconfig("adv_debug['mode']", $adv_debug['mode'], "../includes/");
 writeconfig("adv_settings['group_page_permissions']", $adv_settings['group_page_permissions'], "../includes/");
 
  echo "<img src=\"images/yes.png\"> Transfered config settings.<br>";
 
 // End config transfer.
 //
  
 //} else if ($_GET['old_version'] == "0.2.9.1" || $_GET['old_version'] == "0.2.9") {
 } else if ($_GET['old_version'] == "0.3.4") {
  // If was a dev build.
  echo "<img src=\"../" .$admin['dir']. "/images/yes.png\"> No changes to be made.";
 } else if ($_GET['old_version'] == "dev") {
  // If was a dev build.
  echo "<img src=\"../" .$admin['dir']. "/images/no.png\"> Development build upgrades are not supported by this upgrader. Please post at our <a href=\"http://www.quate.net/board/\">forums</a> for upgrade help.";
  require("footer.php");
  exit();
 }
 
 echo "<br>Success. You may delete this upgrade folder if you wish.<br><br>";
 
 // Finished
 // Create 'lock' file
 if (!$file_open = fopen("lock", "a")) {
  echo "<img src=\"images/no.png\"> Failed to create a file called 'lock' to lock this upgrade script.<br>";
  // (Script is not to exit, but is to contine.)
 } else {
  fclose($file_open); // Close file.
  echo "<img src=\"images/yes.png\"> Created a file called 'lock' to lock this upgrade script.<br>";
 }
 echo "<br><input type=\"button\" value=\"Continue\" onclick=\"document.location.href = '../admin/login.php';\">";
 require("footer.php");
 exit();
}
?>
<form action="index.php" method="get">
<img src="../<?php echo $admin['dir']; ?>/images/cmslogo.png" style="margin: 7px;">
<table cellspacing="0" cellpadding="0">
<tr>
       <td><img src="../<?php echo $admin['dir']; ?>/images/install.png" width="48" height="48" alt="" border="0" hspace="5"></td>
       <td width="500">This is the upgrade page for the QuateCMS. If you have any trouble, visit our <a href="http://www.quate.net/board/">forums</a>.</td>
</tr>
</table>
<table cellspacing="0" cellpadding="1" width="400" style="margin:1px;margin-left:2px;margin-right:2px;">
<tr>
       <td width="200"><b>Previous CMS version</b><br>What was the previous QuateCMS version installed?</td>
       <td><select name="old_version">
<option value="0.3.4">0.3.4
<option value="0.3.3">0.3.3
<option value="0.3.2">0.3.2
<option value="0.3.1">0.3.1
<option value="0.3">0.3
<option value="0.2.9.1">0.3 RC2 (0.2.9.1)
<option value="0.2.9">0.3 RC1 (0.2.9)
<option value="dev">Some development build
</select></td>
</tr>
<tr>
       <td><input name="cfm" type="hidden" value="1"></td>
       <td><input type="submit" value="Upgrade"></td>
</tr>
</table>
</form>
<?php
require("footer.php");
?>